;	>> Generator 
;
;100 ------------------------------
;110 REM FIELD GENERATOR
;120 ------------------------------
;130 GRAPHICS 15
;140 COLOR %1:PLOT 128,0:DRAWTO 128,191
;150 COLOR %1:PLOT 0,138:DRAWTO 128,138
;160 COLOR %1:PLOT 0,0:DRAWTO 128,0
;170 COLOR %3
;180 DEG :FRAMES=32
;190 OX=63.499999:OY=OX-21.5:R=83:M=255:KZ=150
;200 DIM K(M),L(M)
;210 OPEN #1,8,%0,"D:FIELD.DAT"
;220 ------------------------------
;230 FOR D=%0 TO 89 STEP (90/FRAMES)
;240   EXEC CALC
;250   EXEC SHOW
;260 NEXT D
;270 CLOSE #%1
;280 END 
;290 ------------------------------
;300 PROC SHOW
;310   FOR P=%0 TO M:PLOT OX+K(P),OY+L(P):NEXT P
;320   FOR P=%0 TO M:PUT #%1,OX+K(P):NEXT P:FOR P=%0 TO M:PUT #%1,OY+L(P):NEXT P
;330 ENDPROC 
;340 ------------------------------
;350 PROC CALC
;360   X1=R*SIN(D):Y1=R*COS(D)
;370   X2=R*SIN(D+90):Y2=R*COS(D+90)
;380   X3=R*SIN(D+180):Y3=R*COS(D+180)
;390   AX=(X1-X2)/15:PX=X2
;400   AY=(Y1-Y2)/15:PY=Y2
;410   BX=(X3-X2)/15
;420   BY=(Y3-Y2)/15
;430   ------------------------------
;440   FOR I=%0 TO M STEP 16
;450     Y=PY:X=PX
;460     FOR J=I TO I+15
;470       F=KZ/(KZ+Y+OX)
;480       K(J)=X*F:L(J)=-Y*F
;490       X=X+AX:Y=Y+AY
;500     NEXT J:? I
;510     PX=PX+BX:PY=PY+BY
;520   NEXT I
;530 ENDPROC 

;

	org	$d4

fprec	= 6
fr0	.ds	fprec
fre	.ds	fprec
fr1	.ds	fprec
fr2	.ds	fprec
frx	.ds	fprec
eexp	=	frx+1
nsign	=	frx+2
esign	=	frx+3
fchrflg =	frx+4
digrt	=	frx+5
cix	.ds	1
inbuff	.ds	2
z1	.ds	2
z2	.ds	2
z3	.ds	2
degrad	.ds	1	; degree or radian units for basic
flptr	.ds	2
fptr2	.ds	2

;   FLOATING POINT ROM ENTRY POINTS
;

	.proc math

afp	= $d800	;Extract a floating point number from an ASCII str. (FR0<--[INBUFF+CIX])
fas	= $d8e6	;Convert a floating point number to an ASCII string returns pointer in INBUFF
ifp	= $d9aa	;Convert a 2-byte integer (FR0) to a floating point number (in FR0)
fpi	= $d9d2	;Convert a floating point number to an integer
zfr0	= $da44	;Zero the floating point register (FR0)
zf1	= $da46	;Zero 6 zero page bytes pointed to by "X"
zpg0	= $da48	;Zero "Y" bytes pointed to by "X"
initbf	= $da51 ;Store the address of LBUFF in INBUFF 
dblz2	= $da5a ;Shift Z2 left one bit (16-bit High/Low format)
fsub	= $da60 ;Subtract FR1 from FR0 (result in FR0) 
fadd	= $da66 ;Add FR1 to FR0 (result in FR0) 
fmul	= $dadb ;Multiply FR0 by FR1 (result in FR0)
fdiv	= $db28 ;Divide FR0 by FR1 (result in FR0) 
skblk	= $dba1 ;Skip 0 or more blanks pointed to by [INBUFF,CIX], result modifies CIX
gchar	= $dbaf ;Read a byte, convert it as an ASCII decimal number, set CY if it is not 
sh0l4	= $dbe4 ;Shift the contents of FR0 left 4 bits
normal	= $dc00 ;Normalize the contents of FR0
plyevl	= $dd40 ;Evaluate the polynomial [Y.X](FR0), with A terms 
fld0r	= $dd89 ;Load FR0 from [Y.X]
fld0p	= $dd8d ;Load FR0 from [FLPTR]
fld1r 	= $dd98 ;Load FR1 from [Y.X]
fld1p 	= $dd9c ;Load FR1 from [FLPTR]
fst0r 	= $dda7 ;Store FR0 into 6 bytes pointed to by [Y.X]
fst0p 	= $ddab ;Store FR0 into [FLPTR]
fmove 	= $ddb6 ;Copy FR0 over into FR1
exp	= $ddc0 ;FR0 <-- exponential function of FR0
exp10 	= $ddcc ;FR0 <-- 10^FR0 (exponent of 10)
redarg 	= $de95 ;FR0 <-- (FR0-[Y.X])/(FR0+[Y.X])
log	= $decd ;FR0 <-- natural log of FR0
log10	= $ded1 ;FR0 <-- base 10 log of FR0
half	= $df6c ;Constant = 0.5000000000
plysin	= $dfae ;11 Constant table for SIN polynomial
none	= $dfea ;Constant = 0.9999999999
sin45	= $dff0 ;Constant = sin(45 deg.)
;
;The following e;ntry points not in the ATARI "D" ROM
;
rstarg	= $dd22 ;Copy PLYARG over into FR1
ldarg	= $dd2d ;Copy PLYARG over into FR0
plyone	= $dd38 ;Same as PLYEVL except implicit 1.0 coefficient
ldply	= $dd62 ;Copy [FPTR2] into FR1, add 6 to FPTR2
savarg	= $dd78 ;Store X into FPTR2, Y into FPTR2+1, copy FR0 over into PLYARG

	
	.macro loadfr0
	ldx <:1
	ldy >:1
	jsr math.fld0r
	.endm

	.macro loadfr1
	ldx <:1
	ldy >:1
	jsr math.fld1r
	.endm

	.macro storefr0
	ldx <:1
	ldy >:1
	jsr math.fst0r
	.endm
	
	.endp

frames	= 32
field_data = $4000

	opt l+
	
	org $80
deg	.ds fprec
x1	.ds fprec
x2	.ds fprec
x3	.ds fprec
x4	.ds fprec
y1	= x2
y2	= x3
y3	= x4

px	= x2
py	= y2
ax	.ds fprec
ay	.ds fprec
bx	.ds fprec
by	.ds fprec
fz	.ds fprec

frame	.ds 1
i	.ds 1
j	.ds 1
xx	.ds fprec
yy	.ds fprec

editrv	= $e400

	org $2000

var_frame	.byte 'F',0

var_x1	.byte 'X1',0
var_y1	.byte 'Y1',0
var_x2	.byte 'X2',0
var_y2	.byte 'Y2',0
var_x3	.byte 'X3',0
var_y3	.byte 'Y3',0

var_ax	.byte 'AX',0
var_ay	.byte 'AY',0
var_bx	.byte 'BX',0
var_by	.byte 'BY',0

start
	jsr copy_rom
	jsr open_editor
	
	jsr reset_time
	
	jsr init_sinus
	
	mva #0 559
	jsr print_time
	jsr generate
	jsr print_time
	mva #34 559
	jmp xxx

	.proc print_time
	lda 20
	sta fr0
	lda 19
	sta fr0+1
	jsr math.ifp
	jsr print_fr0
	jsr print_newline
	jsr reset_time
	rts
	.endp
	
	.proc reset_time
	lda:cmp:req 20
	
	lda #0
	sta 20
	sta 19
	sta 18
	rts
	.endp
;===============================================================

open_editor
	jsr open_editor1
	lda #0
	sta 82
	lda #125
	jsr put_char
	rts

open_editor1
	lda editrv+1
	pha
	lda editrv
	pha
	rts

;===============================================================

xxx	lda $d40b
	sta $d01a
	jmp xxx

;===============================================================

	.proc init_sinus
	mva #frames-1 frame
loop
	ldx frame
	txa
	jsr store_sinus_mirror
	
	lda #frames
	sec
	sbc frame
	tax
	lda frame
	eor #$20
	jsr store_sinus_mirror

	dec frame
	bpl loop
	rts

store_sinus_mirror
	pha
	lda precalc,x
	sta fr0
	lda #0
	sta fr0+1
	jsr math.ifp
	pla
	pha
	jsr store_sinus
	lda fr0
	beq zero	;Negate if not zero
	eor #$80
	sta fr0
zero	pla
	eor #2*frames
store_sinus
	tax
	.rept fprec
	lda fr0+#
	sta sinus+#*(frames*4),x
	.endr
	rts
precalc	
	.byte $00,$04,$08,$0C,$10,$14,$18,$1C,$20,$23,$27,$2B,$2E,$31,$35,$38
	.byte $3B,$3D,$40,$43,$45,$47,$49,$4B,$4D,$4E,$4F,$51,$51,$52,$53,$53,$53
	.endp

;===============================================================

	.proc get_sinus
	tay
	.rept fprec
	lda sinus+#*(frames*4),y
	sta $00+#,x
	.endr

	tya		;add 90 degrees
	clc
	adc #frames
	rts
	.endp

;===============================================================

	.macro m_assign_x_from_y
	ldx #:1
	ldy #:2
	jsr assign_x_from_y
	.endm

	.proc assign_x_from_y 
	.rept fprec
	lda $00+#,y
	sta $00+#,x
	.endr
	rts
	.endp

	.macro m_add_y_to_x
	ldx #:1
	ldy #:2
	jsr add_y_to_x
	.endm

	.proc add_y_to_x 
	stx adr2
	sty adr1
	ldy #0
	jsr math.fld0r
	ldx #0
adr1	= *-1
	ldy #0
	jsr math.fld1r
	jsr math.fadd
	ldx #0
adr2	= *-1
	ldy #0
	jsr math.fst0r

	rts
	.endp

;===============================================================

	.proc generate
	mva #0 frame
loop_frame
	lda frame
	ldx #<x1
	jsr get_sinus
	ldx #<x2
	jsr get_sinus
	ldx #<x3
	jsr get_sinus
	ldx #<x4
	jsr get_sinus

	m_print_byte var_frame frame
	m_print

	m_print_float var_x1 x1
	m_print_float var_y1 y1
	m_print
	m_print_float var_x2 x2
	m_print_float var_y2 y2
	m_print
	m_print_float var_x3 x3
	m_print_float var_y3 y3
	m_print
	
	m_subdiv15 ax x1 x2
	m_subdiv15 ay y1 y2
	m_subdiv15 bx x3 x2
	m_subdiv15 by y3 y2
	
	m_print_float var_ax ax
	m_print_float var_ay ay
	m_print
	m_print_float var_bx bx
	m_print_float var_by by
	m_print
;
	m_print

	mva #16 i
loop_i
	m_assign_x_from_y xx px	;X=PX
	m_assign_x_from_y yy py	;Y=PY
	mva #16 j
loop_j
;	math.loadfr0 kzox	; FZ=KZ/(KZ+Y+OX)
;	math.loadfr1 yy
;	jsr math.fadd
;	jsr math.fmove
;	math.loadfr0 kz
;	jsr math.fdiv
;
;	math.storefr0 fz
;	jsr math.fmove		;FR1=FZ
;
;	math.loadfr0 xx		;FR0=XX*F
;	jsr math.fmul
	math.loadfr1 ox
	jsr math.fadd
;	
	jsr math.fpi
	lda fr0
	sta field_data+$000
pokex_adr = *-2
	inw pokex_adr
;
;	math.loadfr1 fz
;	lda fr1			;FR1=-FR1
;	beq *+4
;	eor #$80
;	sta fr1
;	math.loadfr0 yy		;FR0=-YY*F
;	jsr math.fmul
	math.loadfr1 oy		;FR0=FR0+OY
	jsr math.fadd
;
	jsr math.fpi

	lda fr0
	sta field_data+$100
pokey_adr = *-2
	inw pokey_adr

	m_add_y_to_x xx ax	;X=X+AX
	m_add_y_to_x yy ay	;Y=Y+AY

	dec j
	jne loop_j

	m_add_y_to_x px bx	;PX=PX+BX
	m_add_y_to_x py by	;PY=PY+BY

	dec i
	jne loop_i

	inc pokex_adr+1		;Skip next page
	inc pokey_adr+1		;Skip next page

	jsr print_time

	inc frame
	lda frame
	sta 712
	cmp #frames
	jne loop_frame
	rts
	.endp

;===============================================================

	.macro m_subdiv15
	lda #:1
	ldx #:2
	ldy #:3
	jsr subdiv15
	.endm

	.proc subdiv15
	sta adr3
	stx adr1
	sty adr2
	ldx #0
adr1	= *-1
	ldy #0
	jsr math.fld0r
	ldx #0
adr2	= *-1
	ldy #0
	jsr math.fld1r
	jsr math.fsub

;	math.loadfr1 const15
;	jsr math.fdiv
	math.loadfr1 const1by15
	jsr math.fmul
	ldx #0
adr3	= *-1
	ldy #0
	jsr math.fst0r
	rts

const15	.fl 15.0
const1by15
	.fl 0.0666666666
	.endp


;===============================================================

ox	.fl 63.499999
oy	.fl 41.999999
kz	.fl 150.0
kzox	.fl 213.99999	;kz+ox
one	.fl 1.1

;===============================================================
	.macro m_print
	jsr print_newline
	.endm
	
	.proc print_newline
	lda #155
	jsr put_char
	rts
	.endp


	.macro m_print_byte
	ldx #<:1
	ldy #>:1
	lda #:2
	jsr print_byte
	.endm


	.proc print_byte
	stx textx+1
	sty texty+1
	sta varadr+1
varadr	lda $00
	sta fr0
	lda #0
	sta fr0+1
	jsr math.ifp
textx	ldx #0
texty	ldy #0
	lda #fr0
	jmp print_float
	.endp
	
	.macro m_print_float
	ldx #<:1
	ldy #>:1
	lda #:2
	jsr print_float
	.endm

	.proc print_float
	stx flptr
	sty flptr+1
	sta varadr+1
loop	ldy #0
	lda (flptr),y
	beq done
	jsr put_char
	inw flptr
	jmp loop

done	lda #'='
	jsr put_char
varadr	ldx #0
	ldy #0
	jsr math.fld0r
	jsr print_fr0
	lda #127
	jsr put_char
	rts
	.endp

	.proc print_fr0
	jsr math.fas
	mva #0 print_fr0_char+1
print_fr0_char
	ldy #0
	lda (inbuff),y
	bmi last
	jsr put_char
	inc print_fr0_char+1
	bne print_fr0_char
last	and #$7f
	jmp put_char
	.endp

;===============================================================
	.proc put_char
icputb = $0346
	ldx #$00
	tay
	lda icputb+1,x
	pha
	lda icputb,x
	pha
	tya
	rts
	.endp
	
;===============================================================
	.proc copy_rom
	sei
	lda #0
	sta $d40e
	tax
osloop	ldy #$ff
	sty $d301
osload	lda $c000,x
	ldy #$fe
	sty $d301
osstore	sta $c000,x
	inx
	bne osloop
	lda osload+2
	cmp #$cf
	bne nocustom
	lda #$df
	sta osload+2
	sta osstore+2
nocustom
	inc osload+2
	inc osstore+2
	bne osloop

	ldy #8
fploop	lda fastfp,x
fpstore	sta $d800,x
	inx
	bne fploop
	inc fploop+2
	inc fpstore+2
	dey
	bne fploop
	lda #$40
	sta $d40e
	cli
	rts

fastfp	ins "Silly-JacField-Generator-fastfp.bin"
	.endp

	.align 256
sinus	.ds fprec*frames*4

	run start


