;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;	This is the "Silly Things Intro Loading Part".

bar_sm	= intro_zp

	org *				;Defined by including file

;===============================================================

	assert_same_1k dl
	.local dl			;Must not cross 1k boundary at $9400
lms_high = dl+4

:2	.byte $70
	.rept 5, #
:4	dta b($4f), a(header_sm+:1*40)
	.endr
:11	.byte $70
:4	dta b($4f), a(bar_sm)
	dta b($41), a(dl)
	.endl


;===============================================================

	.proc init

 	lda #setvbv.immediate		;Animate logo during loading
 	ldx #>vbi.with_sound
 	ldy #<vbi.with_sound
 	jsr setvbv

	ldx #7
fade_up_loop				;Fade up/down to hide pixel shift between graphics 9 and 10
	lda #3
	jsr wait.cnt
	lda pcolor0
	clc
	adc #2
	sta pcolor0
	sta color4
	dex
	bne fade_up_loop

 	jsr sync.cnt
 	mva #0 sdmctl			;Screen off

 	jsr sync.cnt
 	mva #$40 gprior			;Graphics 9
 	mwa #dl sdlstl			;New DL

 	jsr header.effect.init		;Init for fast mode
	jsr header.effect.init_colors
	lda #>intro_header_start	;Free memory area
	ldx #<dl.lms_high		;High byte of LMS instruction
	ldy #>dl.lms_high		;High byte of LMS instruction
	jsr header.effect.init_fast_mode
 	jsr header.effect.init		;Init for normal mode again
	jsr header.effect.init_maps
	mva #$20 vbi.with_sound.jsr_adr	;Activate move in VBI

	jsr bar.init

 	jsr sync.cnt
 	mva #$22 sdmctl			;Screen on
 
	ldx #7				;Fade screen down again
fade_down_loop
	lda #3
	jsr wait.cnt
	lda color4
	sec
	sbc #2
	sta color4
	dex
	bne fade_down_loop

fade_down_loop2				;Fade logo down in normal mode
	.if .not .def fast_mode
 	jsr sync.cnt
 	.endif
	jsr header.effect.fade_down
	bpl fade_down_loop2
 
;wait_cmc
;	lda letter.sound.player.possng
;	cmp #7
;	bcc wait_cmc
;	lda letter.sound.player.posptr
;	cmp #$38-$20
;	bcc wait_cmc

	ldx #0				; Fades the current sound out to silence
	ldy #37
fade_loop
	stx letter.sound.player.master_volume_reduction
fade_color_loop
	jsr sync.cnt
	cpy #$ff
	beq fade_color_skip
	lda bar_sm,y
	sec
	sbc #1
	sta bar_sm,y
	asl
	asl
	asl
	asl
	ora #$0f
	sta bar_sm+1,y
	and #$f0
	bne fade_color_loop
	dey
	dey

	cpy #24
	bcs fade_loop
fade_color_skip
	inx
	cpx #16
	bne fade_loop


  	lda #setvbv.immediate		;Animate logo in fast mode during loading
 	ldx #>vbi.with_bar
 	ldy #<vbi.with_bar
 	jmp setvbv			;And return to DOS
	
	.endp		;End of init

;===============================================================
	.local bar

	.macro next
?old_pc	= *
	ini intro.loading.bar.next_index
	org ?old_pc
	.endm

	.proc init
	ldx #39
	lda #$ff
loop	sta bar_sm,x
	dex
	bpl loop
	lda #$0f
	sta bar_sm
	eor #$ff
	sta bar_sm+39
	rts
	.endp

	.proc next_index
wait	jsr sync.cnt
	ldx vbi.with_bar.bar_lda_adr
	cpx #40
	beq last
	lda $00,x		;Wait until current block is zero
	bne wait
	cpx #[<bar_sm+1]
	bne not_first
	dex			;From block $01 to $00
	bne first
not_first
	cpx #40
	beq last
	inx			;From $00 to $02 to ...
	inx
first	stx vbi.with_bar.bar_lda_adr
	stx vbi.with_bar.bar_sta_adr1
	inx
	stx vbi.with_bar.bar_sta_adr2
last	rts
	.endp

	.proc finish
loop	jsr next_index
	cpx #[<bar_sm+40]
	bcc loop
	rts
	.endp

	.endl	;End of bar
	
;===============================================================

	.proc wait.cnt
	clc
	adc $14
loop	cmp $14
	bne loop
	rts
	.endp

	.proc sync.cnt
	lda $14
loop	cmp $14
	beq loop
	rts
	.endp		;End of sync.cnt

;===============================================================

	.proc vbi

	.proc with_sound
	jsr letter.sound.play
jsr_adr bit header.effect.move
	jmp sysvbv
	.endp

	.proc with_bar

	jsr header.effect.move_fast_mode;
	ldy lms_offset,x	;Set the 20 high bytes of the LMS instructions
	sta dl.lms_high,y
	sta dl.lms_high+3,y
	sta dl.lms_high+6,y
	sta dl.lms_high+9,y

	lda bar_sm
bar_lda_adr = *-1		;Zero page addres, therefore -1 only
	beq zero
	sec
	sbc #1
	sta bar_sm
bar_sta_adr1 = *-1
	asl
	asl
	asl
	asl
	sta bar_sm+1
bar_sta_adr2 = *-1
zero
	jmp sysvbv
	
lms_offset .byte 0,0,12,24,36,48

	.endp

	.endp	;End of vbi

	