
; Constants
max_columns = 80
max_rows= 24

; Zero page
cnt	= $14

p1	= $80
p2	= $82
p3	= $84
p4	= $86

; Main memory
sm1	= $4100
sm2	= $6100
sm_size	= sm2-sm1


	org $2000
	
	icl "../Silly-Kernel-Equates.asm"
	icl "../Silly-Kernel.asm"

	.proc main

	sei
	lda $d40b
	bne *-3
	sta dmactl
	sta nmien
	sta irqen
	

	mwa #dl.dl1 dlptr

	mva #6 colpf1
	mva #0 colpf2

	jsr sync.vcount
	mva #$22 dmactl

	jsr print
	jmp *

	.local dl
dc	= $0f

dl1	dta $70,$70,$70
	dta $40+dc,a(sm1)
:95	dta dc
	dta $40+dc,a(sm1+$f00)
:95	dta dc
	dta $41,a(dl2)

dl2	dta $70,$70,$70
	dta $40+dc,a(sm2)
:95	dta dc
	dta $40+dc,a(sm2+$f00)
:95	dta dc
	dta $41,a(dl1)

	.endl
;===============================================================

	.proc print
	.var xpos .byte
	.var ypos .byte
	.var current_char .byte

	clear_memory sm1,$2000
	clear_memory sm2,$2000

	ldx #0
	mva #0 ypos

	mwa #sm1 p3
text_loop
	lda text
text_adr = *-2
	sta current_char
	beq text_done
	inw text_adr
	cmp #$0a
	beq new_line
	cmp #$9b
	beq new_line
	cmp #$0d
	beq text_loop
	bne normal_char

new_line
	stx p1
	lda #max_columns
	sec
	sbc p1
	lsr

	clc
	adc p3
	sta p3
	lda p3+1
	adc #0
	sta p3+1
	jmp next_line
	
normal_char
	lda #0
test_adr = *-1
	inc test_adr
;	sta current_char
	jsr copy_char
	inx
	cpx #max_columns
	bne same_line

next_line
	adw p3 #280 
	ldx #0
	inc ypos
	lda ypos
	cmp #max_rows
	bne same_line
	jmp text_done
same_line
	jmp text_loop

text_done
	rts

;===============================================================

	.proc copy_char	;Copy current char a position <X> to (p2), (p4)
	.var count .byte

	lda current_char
	cmp #96
	bcc *+4
	sbc #96
	
	sta p1
	sta p2
	lda #>chr
	sta p1+1
	clc
	adc #4
	sta p2+1
	
	lda p3
	sta p4
	lda p3+1
	adc #>sm_size
	sta p4+1

	mva #8 count
	txa
	and #1
	bne copy_bytes_right
copy_bytes_left

	lda (p1),y
	and #$f0
	sta (p3),y
	lda (p2),y
	and #$f0
	sta (p4),y
	adw p1 #$80
	adw p2 #$80
	adw p3 #40
	adw p4 #40
	dec count
	bne copy_bytes_left
	sbw p3 #320
	rts

copy_bytes_right
	lda (p1),y
	and #$0f
	ora (p3),y
	sta (p3),y
	lda (p2),y
	and #$0f
	ora (p4),y
	sta (p4),y
	adw p1 #$80
	adw p2 #$80
	adw p3 #40
	adw p4 #40
	dec count
	bne copy_bytes_right
copy_bytes_done
	sbw p3 #319
	rts
	.endp	;End of copy_char

	.endp	;End of print
	
	.endp	;End of main
;===============================================================

	.align $100
chr	ins "SillyNote-Char.pic"

text	ins "../SillyThings.nfo"
	.byte 0

	run main
	
