;	Convertes two 7680 bytes picture to interleaved $140 bytes charset chunks.
;	Write result using "write 9400 cfff C:\jac\system\Atari800\Programming\Demos\SillyThings\split\Silly-Split-Pictures.dat"
;	Write result using "write 9400 cfff C:\jac\system\Atari800\Programming\Demos\SillyThings\split\Silly-Split-Test-Pictures-C.dat"
;	Write result using "write 9400 cfff C:\jac\system\Atari800\Programming\Demos\SillyThings\split\Silly-Split-Test-Frame.dat"

;	Druid/Gauntlet			: 15360 unpacked, 8988 bytes packed  
;	Spiral-1.mic/Spiral-2.mic	: 15360 unpacked, 8917 bytes packed

;	.def test	;Uncomment to generate test pictures with only 1 color

p1	= $90
p2	= $92

chr_size	= $140
chr_end		= $d000-2*chr_size
char_width	= 40
char_height	= 24

	opt l+

	org $400
	
start	lda $d40b
	bne start
	sei
	sta $d40e
	sta $d400
	sta $d20e
	lda #$fe
	sta $d301

	.if .def test
	mwa #picture1 p1
	lda #$55
	jsr fill_picture

	mwa #picture2 p1
	lda #$ff
	jsr fill_picture
	.endif

	mwa #[picture2_end-320] p1
	mwa #chr_end+chr_size p2
	jsr copy_picture

	mwa #[picture1_end-320] p1
	mwa #chr_end p2
	jsr copy_picture
	
loop	lda $d40b
	sta $d01a
	jmp loop

;===============================================================
	.proc copy_picture

	mva #char_height line_count
copy_line
	mva #char_width char_count
	ldy #0
copy_char
	ldy #40*0
	lda (p1),y
	ldy #4
	sta (p2),y
	ldy #40*1
	lda (p1),y
	ldy #5
	sta (p2),y
	ldy #40*2
	lda (p1),y
	ldy #6
	sta (p2),y
	ldy #40*3
	lda (p1),y
	ldy #7
	sta (p2),y
	ldy #40*4
	lda (p1),y
	ldy #0
	sta (p2),y
	ldy #40*5
	lda (p1),y
	ldy #1
	sta (p2),y
	ldy #40*6
	lda (p1),y
	ldy #2
	sta (p2),y
	inc p1+1
	ldy #<(40*7)
	lda (p1),y
	ldy #3
	sta (p2),y

	dec p1+1
	inw p1
	adw p2 #8

	dec char_count
	bne copy_char

	sbw p1 #[320+char_width] 
	sec
	lda p2
	sbc #<[320+2*chr_size]
	sta p2
	lda p2+1
	sbc #>[320+2*chr_size]
	cmp #$d8		;skip $d00-$d7ff
	bcs noskip
	cmp #$d0
	bcc noskip
	sec
	sbc #($d8-$d0)
noskip	sta p2+1

	dec line_count
	jne copy_line
	rts

line_count .ds 1
char_count .ds 1

	.endp

;===============================================================

;	.if .def test
	.proc fill_picture
	sta color
	ldx #240
loop_lines
	ldy #0
loop_bytes
	txa
	and #7
	cmp #7
	beq seven
	lda #$ff
	sta mask
	jmp store
seven	lda #$aa
	sta mask

store	lda #0
color	= *-1
	and #$ff
mask	= *-1
	sta (p1),y
	iny
	cpy #40
	bne loop_bytes
	adw p1 #40 
	dex
	bne loop_lines
	rts
	.endp
;	.endif

;===============================================================

;	240 lines, 40 bytes per lines, plus 4 col/lum values
picture1
	ins "Silly-Split-Spiral-1.mic",+1000,7680
;	ins "Silly-Split-Test-Picture-1.pic"
;	ins "Silly-Split-Test-Frame-1.mic", 0, 7680
picture1_end

picture2
	ins "Silly-Split-Spiral-2.mic",+1000,7680
;	ins "Silly-Split-Test-Picture-2.pic"
;	ins "Silly-Split-Test-Frame-2.mic", 0, 7680
picture2_end


	run start
	
	.print "Picture 1: ", picture1
	.print "Picture 2: ", picture2
