;
;	>>> Silly Things by JAC! <<<
;
;	Created 2010-10-10/2010-12-09 for the Sillyventure 2010 in Gdansk.
;
;	Graphics by OOZ.

; Constants
split_chr_size		= $400	;Full charset
split_pic_size		= $140	;Once char line is the picture
split_pic_one		= $04	;Charset EOR value to display the first pic
split_pic_two		= $00	;Charset EOR value to display the first pic

split_offset		= 8	;Special lines at the top (not usable)
split_char_width	= 40	;Visible screen width in characters
split_char_height	= 24	;Visible screen height in characters
split_char_splits	= 32	;Number of split positions, effective number of splits is char_splits+1
split_lines_height	= split_char_height*8		;Visible screen height in lines
split_lines_height2	= split_char_height*8+split_offset	;Visible screen height in lines plus leading special lines

split_delay		= 16	;Time after WSYNC before split lines kernel starts
split_player		= 0	;Number of the player to use for overlay


; Zeropage
split_cnt		= split_zp
split_chr_zp		= split_zp+$10	;ZP, $08+$c0+$08 bytes

; Main Memory
split_header_routine_old= $1800	;Temporary during init, $347 bytes
split_header_routine_new= $1b47	;Temporary during init, $347 bytes
split_header_sm		= $1f00	;Temporary during init, $c8 bytes

split_pictures_dfl	= $dd25	;Packed pictures, copied to the end of memory ($FFF9)
split_pictures_start	= $3800	;Unpacked pictures before segmentation
split_pictures_end	= split_pictures_start+$3c00

split_chr_empty		= $1800	;$1800-$193f and $1c00-$1c3f must be empty
split_chr_start		= $3800	;40 chars pic
split_chr_end		= $10000

generated_lines		= generated_lines_end-$d25
generated_lines_end	= $3800;$d25 bytes of linear code
generated_headers	= $3e00;32 used = 32 pages of fast mode header copies (200 bytes each) sharing the same pages as the generated splits
generated_splits	= $3ec8;Generated routines, char_splits+1 = 33 entries, 2 entries in 4 pages, occupies (33/2)*4=$44 pages
generated_stores 	= $8200;Generated routines, (lines_height+1)*12 = $90c bytes distributed 5 blocks of $200 bytes ($82/3, $86/7, $8a/b, $8e/f, $92/3)
generated_eors	 	= $9600;Generates routine, (lines_height)*(3+2+2) = $540 bytes distributed 3 blocks of $200 bytes ($96/7, $9a/b, $9e, $9f)
generated_next		= $a200;Next free block up to $ee/ef about $30 pages free, $b600 used as header_sm first

;	Available pages
;	$a2, $a3, $a6, $a7, $aa, $ab, $ad, $af = $800 bytes
;	$b2, $b3,      $b7, $ba, $bb, $bd, $bf = $700 bytes
;	$c2, $c3, $c6, $c7, $ca, $cb, $cd, $cf = $800 bytes	;c2 and $c3 only after last inflate
;	$da, $db, $dc = $300 bytes

split_end		= $a200	;24 lines with 69 bpl = $678 bytes stores in 4 pairs of split pages
split_end_and_mask1	= $b200	;$100 bytes of AND mask, normal
split_end_and_mask2	= $b300	;$100 bytes of AND mask, inverted
split_end_char_width	= 69	;Bytes per line

split_imx		= $da00	;$41 words = $82 bytes with integer rotator step rates (mx)
split_sinus		= $db00	;Sinus 256 

split_effect_tab1	= $ee00	;Free pages for effect routines

split_sm		= $f140	;char_width*2 bytes, permanent
split_chrs		= $f200	;lines_height bytes with high bytes of charser per visible screen line, permanent
split_free		= $f300	;Free page
split_header_pages	= $f540	;32 entries, permanent, high bytes of user generated_headers
split_xpos		= $f601	;Split effective x position, permanent, with low byte 1 to allow dex/bne loop with -1
split_vars		= $f600	;General purpose page for local variables in generation procedures, temporary
split_xhi		= $f700	;Split routine high byte for every PM xpos, permanent

split_pages		= $f940	;char_splits+1 entries, tempoary during generation
split_jsrlo		= $fa00	;Split routine jsr address low byte, lines_height2 bytes used in generate_stores, temporary during generation
split_jsrhi		= $fb00	;Split routine jsr address high byte, lines_height2 bytes used in generate_stores, temporary during generation
split_xposlo		= $fe00	;Split routine lda/y operand low byte, lines_height2 bytes used in generate_stores, temporary during generation
split_xposhi		= $ff00	;Split routine lda/y operand low byte, lines_height2 bytes used in generate_stores, temporary during generation


;===============================================================

	.local operations

	.use main

	.if .def fast_mix
remix
	dta b(operation.mwa), a(no_operation), a(header_adr)			;Stop header animation
	dta b(operation.mwa), a(no_operation), a(flasher_adr)			;Stop flasher
	dta b(operation.call), a(no_operation)					;Remaining effects are executed in synchronous mode

	dta b(operation.init),a(split.init)
	dta b(operation.mva),b($24),a(effect.flasher.move.white2)		;Activate pure white for colpf2 using BIT ZP
	dta b(operation.mva),b($0a),a(effect.flasher.move.brightness1)		;Activate lighter colpf1 ($08 instead of $0a)

	.if .def fast_mode
	dta b(operation.mva),b($18),a(mpt_player.pozsng)			;Test!
	.endif

	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($18),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.roller.init)
	
	dta b(operation.wait_value),b($1a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.wait_value),b($30),a(mpt_player.pozptr)			;Wait for sound
	dta b(operation.init),a(split.effect.fader.init)

	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($1c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.roller.init)
	dta b(operation.wait_value),b($1e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.wait_value),b($30),a(mpt_player.pozptr)			;Wait for sound
	dta b(operation.init),a(split.effect.fader.init)

	dta b(operation.mwa),a(+$1f10),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($20),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.wait_value),b($22),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.wait_value),b($24),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.mwa),a(+$1f20),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($26),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.wiper.init)
	dta b(operation.wait_value),b($28),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.striper.init)
	dta b(operation.wait_value),b($2a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.wiper_to_middle.init)
	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($2c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.rotator.move)			;Call mode
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($2e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($30),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($32),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.call),a(split.effect.ender.move)			;Rotator plus ender
	dta b(operation.mwa),a(+$1fc0),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($34),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($36),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($38),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mwa),a(+$1fb0),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva), b(+$a), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$a), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.rotator.move)			;Call mode
	dta b(operation.mva), b(+$d), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$d), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($40),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.swinger.move)			;Call mode
	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($50),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init), a(split.effect.noiser.init)

	.else									;End of remix operations

;===============================================================
original
	dta b(operation.mwa), a(no_operation), a(header_adr)			;Stop header animation
	dta b(operation.mwa), a(no_operation), a(flasher_adr)			;Stop flasher
	dta b(operation.call), a(no_operation)					;Remaining effects are executed in synchronous mode

	dta b(operation.init),a(split.init)
	dta b(operation.mva),b($24),a(effect.flasher.move.white2)		;Activate pure white for colpf2 using BIT ZP
	dta b(operation.mva),b($0a),a(effect.flasher.move.brightness1)		;Activate lighter colpf1 ($08 instead of $0a)

	.if .def fast_mode
	dta b(operation.mva),b($3e),a(mpt_player.pozsng)			;Test!
	dta b(operation.jump),a(test)						;Test!
	.endif

	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($24),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.roller.init)
	
	dta b(operation.wait_value),b($26),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.wait_value),b($30),a(mpt_player.pozptr)			;Wait for sound
	dta b(operation.init),a(split.effect.fader.init)

	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($28),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.roller.init)
	dta b(operation.wait_value),b($2a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.wait_value),b($30),a(mpt_player.pozptr)			;Wait for sound
	dta b(operation.init),a(split.effect.fader.init)

	dta b(operation.mwa),a(+$1f10),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($2c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.wait_value),b($2e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.wait_value),b($30),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.shutter.init)
	dta b(operation.mwa),a(+$1f20),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($32),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.wiper.init)
	dta b(operation.wait_value),b($34),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.striper.init)
	dta b(operation.wait_value),b($36),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init),a(split.effect.wiper_to_middle.init)
	dta b(operation.mwa),a(+$1f30),a(effect.flasher.new_color)		;Flash
	dta b(operation.wait_value),b($38),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.rotator.move)			;Call mode
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($3e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)

test	dta b(operation.wait_value),b($40),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call),a(split.effect.ender.move)			;Rotator plus ender
	dta b(operation.mwa),a(+$1fc0),a(effect.flasher.new_color)		;Flash
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($42),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($44),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(+$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($46),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$1), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($48),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.rotator.move)			;Call mode
	dta b(operation.mva), b(+$a), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($4a),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$a), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($4c),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(+$d), a(split.effect.rotator.speed)
	dta b(operation.wait_value),b($4e),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.mva), b(-$d), a(split.effect.rotator.speed)

	dta b(operation.wait_value),b($50),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.call), a(split.effect.swinger.move)			;Call mode
	dta b(operation.mwa),a(+$1f80),a(effect.flasher.new_color)		;Flash

	dta b(operation.wait_value),b($60),a(mpt_player.pozsng)			;Wait for sound
	dta b(operation.init), a(split.effect.noiser.init)

	.endif									;End of original operations
	.endl

;===============================================================

	.proc init

	jsr sync.cnt				;Disable main screen
	mwa #silly_dl.vbl silly_dl.dlv
	mwa #dli.with_header_and_music silly_dli.dliv

	jsr split_header.init			;Prepared copy of old routine and new fast mode routine
	jsr sync.cnt				;Switch an copy of old routine
	mva header.effect.map_cnt dli.with_everything.map_cnt
	mwa #split_header.move dli.with_header_and_music.header_adr

	jsr memory.init				;Create interleaved memory layout with pictures and data
	mva #$ad poke.poke_a			;Simulation mode to fill split_jsrlo/hi
	jsr generate_lines			;Call lines kernel generation simulation
	mva #$8d poke.poke_a			;Real mode again
	jsr routines.init			;Generate kernel in simulation mode
	
	jsr split_header.init_fast_mode		;Fill the gaps in the splits with the fast mode header data
	jsr sync.cnt				;Activate fast mode header
	mwa #dli.with_everything silly_dli.dliv

	jsr generate_lines			;Finally generate the kernel in real mode
	jsr init_splits

	.if .def fast_mode
	lda #14
;	sta colpm0+split_player
	.endif

	jsr sync.cnt
	mwa #dl silly_dl.dlv				;Activate DL
	mva #$20 dli.with_everything.kernel_jsr_adr	;Activate kernel

	lda #10						;Delay to ensure screen synchronizations
	jsr wait.cnt

	rts

;===============================================================
	.proc generate_lines

char_count	= split_vars
line_count	= split_vars+1
split_reg	= chbase
;split_reg	= colbk	; for testing

	mwa #generated_lines  poke.poke_adr
	mva #0 line_count

	jsr normal_lines

	mva #split_char_height+1 char_count
generate_lines_loop
	jsr full_line
	dec char_count
	bne generate_lines_loop
	jmp poke.poke_rts


full_line
	jsr bad_line

normal_lines
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jsr normal_line
	jmp normal_line

bad_line
	lda #$8e		;stx vscrol
	ldx #<vscrol
	ldy #>vscrol
	jsr poke.poke_axy
	
	lda #$8c		;sty hpospx
	jmp split_line

normal_line
	lda line_count
	and #7
	beq first_line
	cmp #6
	beq last_line
	ldx #1
	jsr  poke.poke_nops
	jmp normal_line2

first_line
	ldx #$a2		;ldx #$04/$0c before bad line
	lda line_count
	and #8
	eor #$0c
	tay
	jsr  poke.poke_xy
	jmp normal_line2

last_line			;last line before a bad line, preload xpos
	lda #$a0		;ldy #xpos[line_count+1]
	jsr  poke.poke_a

	ldx line_count
	lda poke.poke_adr
	sta split_xposlo+1,x
	lda poke.poke_adr+1
	sta split_xposhi+1,x
	
	lda #0
	jsr poke.poke_a
	
normal_line2
	lda #$a9		;lda #xpos[line_count]
	jsr poke.poke_a

	ldx line_count
	lda poke.poke_adr
	sta split_xposlo,x
	lda poke.poke_adr+1
	sta split_xposhi,x
	
	lda #0
	jsr poke.poke_a
	
	lda #$8d		;sta hpospx

split_line
	ldx #<[hposp0+split_player];sta hpospx (normal lines) or sty hpospx (bad lines)
	ldy #>[hposp0+split_player]
	jsr poke.poke_axy

	ldx #$a5		;lda chract+1+line_count (zp)
	lda line_count
	sec
	adc #split_chr_zp
	tay
	jsr poke.poke_xy

	jsr sta_split_reg

	ldx #$49		;eor #$04
	ldy #$04
	jsr poke.poke_xy

	ldx #$20		;jsr generated_splits
	ldy #<generated_splits
	jsr poke.poke_xy

	ldx line_count		;remember location of high by for jsr address
	lda poke.poke_adr
	sta split_jsrlo,x
	lda poke.poke_adr+1
	sta split_jsrhi,x

	lda #>generated_splits
	jsr poke.poke_a

	inc line_count
	rts

sta_split_reg
	lda #$8d		;sta split_reg
	ldx #<split_reg
	ldy #>split_reg
	jmp poke.poke_axy

	.endp			;End of generate_lines

;===============================================================
	.proc init_splits	;Initialize runtine tables

	lda #0			;Setup playerfields
	sta colpf0
	sta colpf1
	sta colpf2

	sta colpm0+split_player	;Setup player
	sta sizep0+split_player
	lda #$ff
	sta grafp0+split_player


	ldx #split_char_width-1
sm_loop	txa			;Two lines with chars 0-39
	sta split_sm,x
	sta split_sm+split_char_width,x
	dex
	bpl sm_loop

	clear_memory split_chr_empty $800

	ldx #7			;8 special scan lines at the top
	lda #>split_chr_empty
first_line_chr_loop
	sta split_chr_zp,x
	dex
	bpl first_line_chr_loop
	
	ldx #0
chr_zp_loop
	lda #>split_chr_empty	;Preset real lines with empty_chr value
	sta split_chr_zp+split_offset,x
	lda #0			;Set xpos to minimum
	sta split_xpos,x
	inx
	cpx #split_lines_height
	bne chr_zp_loop

	jmp generated_stores	;Preset all values and pointers with real values
	.endp			;End of init_splits


	.endp			;End of init

;===============================================================

	.proc kernel		;Synchronous screen update

	sta wsync
	sta nmires		;Required because VBI will occur
	lda #5
	sta vscrol		;Preset VSCROL

;	Wait some more
	sta wsync
	.rept split_delay
	nop
	.endr
	
	jsr generated_lines	;JSR instead of JMP brings the required additional delay
	rts

	.endp			;End of kernel

;===============================================================

	.local effect	;Animate x positions

;===============================================================

	.proc clear_picture	;Private
	ldx #split_lines_height
	lda #>split_chr_empty	;Preset real lines with empty_chr value
clear_loop
	sta split_chr_zp+split_offset-1,x
	dex
	bne clear_loop
	rts
	.endp

	.proc set_picture_one	;Private
	jsr sync.cnt
	lda #split_pic_one
	jsr set_picture
	lda #0
	jmp set_all_xpos
	.endp
	
	.proc set_picture	;Private
	sta picture
	ldx #0
loop	lda split_chrs,x
	eor #$00
picture = *-1
	sta split_chr_zp+split_offset,x
	inx
	cpx #split_lines_height
	bne loop
	rts
	.endp

	.proc set_all_xpos	;Private
	stx save_x
	ldx #split_lines_height
loop	sta split_xpos-1,x
	dex
	bne loop
	jsr generated_stores
	ldx #0
save_x = *-1
	rts
	.endp

	.proc set_color
	txa
	and #3
	tay
	lda offset_tab,y
	sta offset
	txa
	lsr
	lsr
	clc
	adc #0
offset = *-1
	tay
	lda color1_tab,y
	beq black1
	ora effect.flasher.color
black1	sta colpf0
	lda color2_tab,y
	beq black2
	ora effect.flasher.color
black2	sta colpf1
	lda color3_tab,y
	beq black3
	cmp #14
	bcs white3
	ora effect.flasher.color
black3
white3	sta colpf2
	rts

offset_tab	.byte 1,0,1,1
color1_tab	.byte $00,$00,$02,$04,$04,$04,$04,$04,$04
color2_tab	.byte $00,$00,$02,$04,$06,$08,$0a,$0a,$0a
color3_tab	.byte $00,$00,$02,$04,$06,$08,$0a,$0c,$0e
	.endp

;===============================================================
	.proc fader
	.proc init
	ldx #31
fade	jsr sync.cnt
	jsr set_color
	dex
	bpl fade
	jsr clear_picture
	jsr sync.cnt
	ldx #31
	jsr set_color
	rts
	.endp			;End of init
	.endp			;End of fader

;===============================================================

	.proc roller
	.proc init
	jsr clear_picture
	jsr sync.cnt
	ldx #31
	jsr set_color
	ldx #0
chr_zp_loop
	jsr sync.cnt
	lda split_chrs,x	;Preset real lines with chr values
	eor #split_pic_one
picture = *-1
	sta split_chr_zp+split_offset,x
	inx
	cpx #split_lines_height
	bne chr_zp_loop
	lda picture
	eor #4
	sta picture
	rts
	.endp			;End of init
	.endp			;End of roller

;===============================================================
	.proc shutter
	.proc init
	lda #32
	sta x1
shift	lda #3
	jsr wait
	ldx #0
loop	txa
	lsr
	lsr
	lsr
	lsr
	sta offset
	txa
	and #15
	clc
	adc #0
offset = *-1
	clc
	adc x1
	cmp #32
	bcs hide
	lda split_chrs,x	;Preset real lines with chr values
	eor #split_pic_one
picture = *-1
	sta split_chr_zp+split_offset,x
hide	inx
	cpx #split_lines_height
	bne loop
	dec x1
	bpl shift

	lda picture
	eor #4
	sta picture
	rts
	.endp			;End of init
	.endp			;End of shutter

;===============================================================

	.proc wiper
	.proc init
	ldx #$20
loop_x1	jsr sync.cnt
	txa
	jsr set_all_xpos
	inx
	cpx #$e0
	bcc loop_x1
	rts
	.endp		;End of init
	.endp		;End of wiper

;===============================================================

	.proc striper
	.proc init
	ldx #0
init_loop
	txa
	and #16
	beq *+4
	lda #$ff
	sta split_effect_tab1,x
	inx
	cpx #split_lines_height
	bne init_loop

	lda #$10
	sta x1
loop_x1	jsr sync.cnt
	ldx #0
loop	lda x1
	eor split_effect_tab1,x
	clc
	.rept 16
	adc #1
	sta split_xpos+#,x
	.endr

	lda split_effect_tab1,x
	and #4
	eor split_chrs,x
	.rept 8
	sta split_chr_zp+split_offset+#,x
	.endr
	lda split_effect_tab1+8,x
	and #4
	eor split_chrs+8,x
	.rept 8
	sta split_chr_zp+split_offset+8+#,x
	.endr
	txa
	clc
	adc #16
	tax
	cpx #split_lines_height
	jne loop

	jsr generated_stores

	inc x1
	lda x1
	cmp #$f0
	jcc loop_x1
	
	jmp set_picture_one

	.endp		;End of init
	.endp		;End of striper

;===============================================================

	.proc wiper_to_middle
	.proc init
	ldx #$28
loop_x1	jsr sync.cnt
	txa
	jsr set_all_xpos
	inx
	cpx #$80
	bcc loop_x1
	rts
	.endp		;End of init
	.endp		;End of wiper to middle

;===============================================================

	.proc rotator
	.var angle = 0 .byte
	.var speed = 0 .byte
 
	.proc move
xpos	= p1
xadd	= p2

	clc
	lda angle
	adc speed
	sta angle

	ldx #split_pic_one
	lda angle
	clc
	adc #$40
	bpl *+4
	ldx #split_pic_two
	stx x1

	jsr generated_eors	;Copy split_chrs eor x1 to split_chr_zp+8

	lda #0
	sta xpos
	lda #80+48
	sta xpos+1

	lda angle
	and #127
	cmp #$40
	and #63
	bcs substart

addstart
	asl
	tax
	lda split_imx,x
	sta xadd
	lda split_imx+1,x
	sta xadd+1

	ldx #95
	ldy #95
	clc			;Outside of the loop
	lda xpos+1		;Outside of the loop

	assert_same_page addloop
	.local addloop
	sta split_xpos,x
	eor #$ff
	sta split_xpos,y
	lda xpos
	adc xadd
	sta xpos
	lda xpos+1
	adc xadd+1
	sta xpos+1
	bcs addoverflow
	iny
	dex
	bpl addloop
	.endl
	jmp generated_stores

addoverflow
	lda #$ff
	jmp overflow

substart
	eor #63			;Negate
	asl
	tax
	lda split_imx+2,x	;Add 1*2 to index
	sta xadd
	lda split_imx+1+2,x
	sta xadd+1

	ldx #95
	ldy #95
	sec			;Outside of the loop
	lda xpos+1		;Outside of the loop

	assert_same_page subloop
	.local subloop	
	sta split_xpos,x
	eor #$ff
	sta split_xpos,y
	lda xpos
	sbc xadd
	sta xpos
	lda xpos+1
	sbc xadd+1
	sta xpos+1
	bcc suboverflow
	iny
	dex
	bpl subloop
	.endl
	jmp generated_stores

suboverflow
	lda #$00
overflow

overloop1
	sta split_xpos,x
	dex
	bpl overloop1

	eor #$ff
overloop2
	sta split_xpos,y
	iny
	cpy #split_lines_height
	bne overloop2
	jmp generated_stores

	.endp	;End of move
	.endp	;End of circle

;===============================================================

	.proc swinger

	.proc move

	ldy #0
	sty shift
	ldx #0
	ldy cnt
loop	tya
	lda split_sinus,y
	clc
	adc split_sinus,x
	ror
	clc
	adc #$00
shift = *-1
	sta split_xpos,x

	iny
	inx
	cpx #split_lines_height
	bne loop
	jmp generated_stores

	.endp	;End of move
	.endp	;End of swinger


;===============================================================

	.proc ender
	.var scan_count = 24	.byte
	.var line_count = 0	.byte

	.proc move

	.var xpos .byte		;bytes
	.var ypos .byte		;lines
	.var offset .byte	;bytes
	.var chars .byte	;characers

	jsr effect.rotator.move
	lda cnt
	and #3
	bne return

	lda scan_count
	cmp #48
	bne next1
	ldx line_count
	cpx #3
	beq next1
	mva offset_tab,x offset
	mva chars_tab,x chars
	mva xpos_tab,x xpos
	mva ypos_tab,x ypos
	mva #0 scan_count
	clc
	lda #<split_end
	adc offset
	sta draw_line.get_byte.split_end_adr
	lda #>split_end
	adc #0
	sta draw_line.get_byte.split_end_adr+1
	inc line_count
	rts			;No more action in this frame
next1
	lda scan_count
	cmp #24
	bcs next2
	jsr draw_line
next2	inc scan_count
return	rts

offset_tab	.byte 0,22,58
chars_tab	.byte 22,36,11
xpos_tab	.byte 9*8,2*8,14*8
ypos_tab	.byte 6*8,16*8,20*8

;===============================================================

	.proc draw_line
	.var char_count .byte
	.var scan_count .byte
	or_mask = x1

	lda #0			;Char offset and scan offset will by in <Y>
	sta p1
	sta p2

	ldy ypos
	lda split_chrs,y
	sta p1+1
	clc
	adc #4
	sta p2+1

	tya
	and #7
	eor #4
	adc xpos		;C=0
	tay
	lda chars
	sta char_count
bytes_loop

	.local get_byte		;Get nex byte into <X>
	ldx split_end
split_end_adr = *-2
	inc split_end_adr
	bne no_inc_high
	inc split_end_adr+1
	lda split_end_adr+1
	lsr
	bcs no_inc_high
	inc split_end_adr+1
	inc split_end_adr+1
no_inc_high
	.endl			;End of get_byte

	txa
	and split_end_and_mask1,x
	sta or_mask
	lda (p1),y
	and split_end_and_mask2,x
	ora or_mask
	sta (p1),y
	lda (p2),y
	and split_end_and_mask2,x
	ora or_mask
	sta (p2),y
	clc
	tya
	adc #8
	tay
	bcc no_inc
	inc p1+1
	inc p2+1
no_inc
	dec char_count
	bne bytes_loop

	lda #split_end_char_width
	sec
	sbc chars
	clc
	adc get_byte.split_end_adr
	sta get_byte.split_end_adr
	bcc no_rest_inc_high
	inc get_byte.split_end_adr+1
	
	lda get_byte.split_end_adr+1
	lsr
	bcs no_rest_inc_high
	inc get_byte.split_end_adr+1
	inc get_byte.split_end_adr+1
no_rest_inc_high
	inc ypos
	rts


	.endp			;End of draw_line
	.endp			;End of move
	.endp			;End of ender

;===============================================================

	.proc noiser
sm	= $4000
chr	= $4000

	.proc init
	sei
	lda #0
	sta nmien
	tax
clear	sta antic,x
	sta pokey,x
	sta gtia,x
	inx
	bne clear
	lda #3
	sta skctl
	lda #$2
	sta audf1
	lda #>chr
	sta chbase
	mwa #dl dlptr
	lda #$23
	sta dmactl
	
	lda #$ff
	sta p1
	lda #2
	sta p1+1
noise_loop
	lda p1+1
	bne normal
	lda p1
	lsr
	lsr
	cmp #$10
	bcc *+4
normal	lda #$0f
	sta bright
	sta audc1
chr_loop
	lda $d20a
	sta chr,x
	sta chr+$100,x
	sta chr+$200,x
	sta chr+$300,x
	sta chr+$400,x
	sta chr+$500,x
	ora #$0c
bright = *-1
	sta colpf1
	inx
	lda vcount
	bne chr_loop
	dec p1
	bne noise_loop
	dec p1+1
	bpl noise_loop
	lda #$ff
	sta portb
	jmp $e477

	assert_same_1k dl

	.local dl
	dta b($42),a(sm)
:32	dta $02
	dta b($41),a(dl)
	.endl
	
	.endp
	.endp

;===============================================================

	.endl	;end of effect

;===============================================================

	assert_same_1k dl

	.local dl
dc	= $04
	.byte $00
	.byte $40+$20+dc
	.word split_sm
	.byte dc
	.rept 14
	.byte $20+dc,dc
	.endr

	.byte $41
	.word silly_dl
	.endl

;===============================================================

	.local dli

	.proc with_header_and_music
	txa
	pha
	tya
	pha
	jsr header.effect.move
header_adr = *-2
	jmp nmi.main_nmi_end
	.endp

	.proc with_everything
	lda #silly_prior
	sta prior

	txa
	pha
	tya
	pha

kernel_jsr_adr
	bit kernel		;Initially disabled

	lda cnt			;Every 4 frames
	and #3
	bne skip_header
	lda #0
map_cnt = *-1
	inc map_cnt
	and #31
	tax
	lda split_header_pages,x
	sta silly_dl.header_lms+1
skip_header

	jsr effect.flasher.move
	inc split_cnt
	jmp nmi.main_nmi_end
	.endp			;End of with_everything

	.endl			;End of dli

;===============================================================

split_code_end

;===============================================================
	.proc split_header	;Special copy, overwritten by generated_lines

header_map1	= $80		;Different from real maps
header_map2	= $a0
header_sm	= split_header_sm

;===============================================================
	.proc init		;Initialize the color map to white
	lda #0
	tax
clear_loop
	sta header_sm,x
	inx
	cpx #200
	bne clear_loop
	
	jsr split_header.init_routine
	jmp split_header.init_colors
	.endp

;===============================================================
	.proc init_routine	;Create copies of the current routine
	copy_memory header.routine split_header_routine_old [ .len header.routine ]
	copy_memory header.routine split_header_routine_new [ .len header.routine]

	mwa #split_header_routine_new p1
loop	ldy #0
	lda (p1),y
	cmp #$8d		;STA header_sm+x?
	bne ignore
	ldy #2
	lda (p1),y
	cmp #>:header_sm	;Old header_sm
	bne ignore
	lda #>header_sm		;New header_sm
	sta (p1),y
	adw p1 #3
	jmp next
ignore	inw p1
next	lda p1+1
	cmp #>[split_header_routine_new + .len header.routine + $ff]
	bne loop
	rts
	.end			;End of init_routine

;===============================================================
	.proc init_colors	;Initialize color addresses based on the color map
	ldx #0
	mwa #[split_header_routine_new+1] store_adr
loop
	lda header.data.header_map,x
	sec
	sbc #[header.header_map1-header_map1]
	ora header.data.header_color,x
	sta $ffff
store_adr = *-2
	lda store_adr
	clc
	adc header.data.header_adradd+1,x	;Add offset to next LDA/ORA
	sta store_adr
	bcc no_inc
	inc store_adr+1
no_inc	inx
	cpx #header.pixels_set
	bne loop
	rts
	.endp

;===============================================================
	.proc init_maps		;Initialize the maps in cylce <Y> with brightness map_fade
	ldx #31
loop	tya
	and #31
	cmp #16
	bcc *+4
	eor #31
	sta header_map2,x
	asl
	asl
	asl
	asl
	sta header_map1,x
	iny
	dex
	bpl loop
	rts
	.endp

;===============================================================
	.proc init_fast_mode	;Uses split_pages as page table 
	.var count	.byte
	lda #0			;Reset all counter
	sta count
	tay			;Phase 0
	jsr init_maps
move_loop
	jsr split_header_routine_new+header.routine.routine1
	jsr split_header_routine_new+header.routine.routine2
	jsr split_header_routine_new+header.routine.routine3
	jsr split_header_routine_new+header.routine.routine4

	ldy header_map2+31
	ldx #30
copy_map
	lda header_map2,x
	sta header_map2+1,x
	asl
	asl
	asl
	asl
	sta header_map1+1,x
	dex
	bpl copy_map
	tya
	sta header_map2
	asl
	asl
	asl
	asl
	sta header_map1

	ldx count		;Get page number from page table
	lda split_pages,x
	sta store_adr+1
	sta split_header_pages,x

	ldx #0			;Copy page content
copy_loop
	lda header_sm,x
	sta $ff00,x
store_adr = *-2
	inx
	cpx #header.header_sm_size
	bne copy_loop

	inc count
	lda count
	cmp #32
	bne move_loop
	rts
	.endp			;End of init_fast_mode

;===============================================================
	.proc move		;Using the old routine
	ldx #0
move_cnt = *-1
	beq jmp_routine1
	dex
	beq jmp_routine2
	dex
	beq jmp_routine3
	dex
	beq jmp_routine4
	dex
	beq scroll_map1
	jmp scroll_map2

jmp_routine1
	inc move_cnt
	jmp split_header_routine_old+header.routine.routine1
jmp_routine2
	inc move_cnt
	jmp split_header_routine_old+header.routine.routine2
jmp_routine3
	inc move_cnt
	jmp split_header_routine_old+header.routine.routine3
jmp_routine4
	inc move_cnt
	jmp split_header_routine_old+header.routine.routine4

scroll_map1
	inc move_cnt
	rts

scroll_map2
	ldy header.header_map2+31
	ldx #30
copy_map
	lda header.header_map2,x
	sta header.header_map2+1,x
	asl
	asl
	asl
	asl
	sta header.header_map1+1,x
	dex
	bpl copy_map
	tya
	sta header.header_map2
	asl
	asl
	asl
	asl
	sta header.header_map1
	inc dli.with_everything.map_cnt

	mva #0 move_cnt
	rts
	.endp

	.endp			;End of split_header

;===============================================================

	.proc routines		;Overwritten by generated_lines

	.proc init
	jsr generate_splits
	jsr generate_stores
	jmp generate_eors
	.endp

;===============================================================
;	Generate split subroutines
	.proc generate_splits

split_count	= split_vars

;	Generate the table of free pages for the split routines
	ldx #0
	ldy #>generated_splits
generate_split_tab_loop
	tya
	sta split_pages,x	;Free pags 2 each charset is reserved for split routines
	iny
	inx
	tya
	sta split_pages,x	;Free page 3 each charset is reserved for split routines
	iny
	inx
	iny			;Page 1 is reserved for charset
	iny			;Page 2 is reserved for charset
	cpx #split_char_splits+1
	bcc generate_split_tab_loop

;	Generate the split routines
	mva #split_char_splits split_count
generate_splits_loop
	ldx split_count
	mva #<generated_splits poke.poke_adr
	lda split_pages,x
	sta poke.poke_adr+1
	jsr generate_split
	dec split_count
	bpl generate_splits_loop

;	Generate the table of high bytes for the split routines
	ldx #0
generate_split_xhi_tab_loop
	txa
	clc
	adc #7
	bcc *+4
	lda #$ff

	ldy #0
generate_split_xhi_tab_find
	cmp pmxpos,y	;Find split routine which is next to the X positions
	bcc generate_split_xhi_tab_store
	iny
	cpy #split_char_splits
	bne generate_split_xhi_tab_find
generate_split_xhi_tab_store
	lda split_pages,y
	sta split_xhi,x
	inx
	bne generate_split_xhi_tab_loop
	rts

	;char_splits bytes of x player position where a split ends
pmxpos	.byte $30,$34,$38,$3c,$44,$4c,$54,$5c,$64,$6c,$74,$7c,$84,$88,$8c,$90
	.byte $94,$98,$9c,$a0,$a4,$a8,$ac,$b0,$b4,$b8,$bc,$c0,$c4,$c8,$c8,$d0


	.proc generate_split
	lda split_count
	and #1
	bne odd

even	lda split_count
	lsr
	tax
	jsr poke.poke_nops
	jsr init.generate_lines.sta_split_reg
	sec
	lda #split_char_splits+1
	sbc split_count
	lsr
	tax
	jmp common


odd	lda split_count	;Replaces 3 NOPS by two BIT $00 instructions to have odd cycles
	cmp #3
	bcc even	;Less thant 3 NOPS available, treat as even
	lda split_count
	cmp #split_char_splits-1
	bcs even

	lsr
	tax
	dex		;One less NOP
	jsr poke.poke_nops

	jsr poke.poke_bit_zp
	jsr init.generate_lines.sta_split_reg
	jsr poke.poke_bit_zp

	sec
	lda #split_char_splits+1
	sbc split_count
	lsr
	tax
	dex		;One less NOP
	dex		;One less NOP	

common	jsr poke.poke_nops
	jmp poke.poke_rts
	.endp		;End of generate_split

	.endp		;End of generate_splits

;===============================================================
;	Subroutine used by "generate_stores" and "generate_eors"

	.proc generate_jmp_next_block
	lda #$4c	;jmp <nextblock>
	jsr poke.poke_a
	lda p1
	jsr poke.poke_a
	clc
	lda p1+1
	adc #>split_chr_size
	sta p1+1
	jmp poke.poke_a
	.endp		;End of generate_jmp_next_block

;===============================================================
; This generates $90c bytes of store instructions
; with JMP links and RTS into 5 blocks of $200 bytes

	.proc generate_stores
	
block_count	= split_vars
block_size	= ($200-3)/(3+3+3+3)
xpos_offset	= 7

	mwa #generated_stores p1
	jsr generate_stores_init_block

	ldx #0
generate_stores_loop
	lda #$ac		;ldy split_xpos+x
	inx			;The table split_xpos starts at low byte 1
	ldy #>split_xpos	;X is already set
	jsr poke.poke_axy
	dex			;Revert inx from above

	lda #$8c		;sty <split_xpos>
	jsr poke.poke_a
	lda split_xposlo+xpos_offset,x
	jsr poke.poke_a
	lda split_xposhi+xpos_offset,x
	jsr poke.poke_a

	lda #$b9		;lda split_xhi,y
	jsr poke.poke_a
	lda #<split_xhi
	jsr poke.poke_a
	lda #>split_xhi
	jsr poke.poke_a

	lda #$8d		;sta <split_jsr>
	jsr poke.poke_a
	lda split_jsrlo+xpos_offset,x
	jsr poke.poke_a
	lda split_jsrhi+xpos_offset,x
	jsr poke.poke_a

	dec block_count
	bne generate_stores_same_block
	jsr generate_jmp_next_block
	jsr generate_stores_init_block
generate_stores_same_block

	inx
	cpx #split_lines_height
	bne generate_stores_loop
	jmp poke.poke_rts

generate_stores_init_block
	mva #block_size block_count
	mwa p1 poke.poke_adr
	rts
	.endp		;End of generate_stores

;===============================================================
; This generates $540 bytes of store instructions
; with JMP links and RTS into 3 blocks of $200 bytes

	.proc generate_eors

block_count	= split_vars
block_size	= ($200-3)/(3+2+2)

	mwa #generated_eors p1
	jsr generate_eors_init_block

	ldx #0
generate_eors_loop
	lda #$ad		;lda split_chrs+x
	ldy #>split_chrs	;X is already set
	jsr poke.poke_axy

	lda #$45		;eor x1
	jsr poke.poke_a
	lda #x1
	jsr poke.poke_a

	lda #$85		;sta split_chr_zp+8+x (ZP)
	jsr poke.poke_a
	txa
	clc
	adc #<[split_chr_zp+8]
	jsr poke.poke_a

	dec block_count
	bne generate_eors_same_block
	jsr generate_jmp_next_block
	jsr generate_eors_init_block
generate_eors_same_block

	inx
	cpx #split_lines_height
	bne generate_eors_loop
	jmp poke.poke_rts

generate_eors_init_block
	mva #block_size block_count
	mwa p1 poke.poke_adr
	rts

	.endp			;End of generate_eors
	.endp			;End of routines


;===============================================================

	.proc memory		;Overwritten by generated_lines

line_count	= split_vars

	.proc init

;	Unpack packed end data to end of free memory
	mwa #split_end_dfl inflater.inputPointer 
	mwa #split_pictures_dfl inflater.outputPointer 
	jsr inflater.inflate

	mwa #split_pictures_dfl copy_two_gap_pages.source_adr
	mwa #split_end copy_two_gap_pages.target_adr
	ldy #4
	jsr copy_two_gap_pages

	jsr init_split_end_and_mask

;	Copy packed picture data from load area to begin end of memory
	.if [ split_pictures_dfl + .len split_pictures_dfl_load -1 ] > $fff9
	.error "split_pictures_dfl exceeds memory due to size ", .len split_pictures_dfl_load , " of DFL file, change location"
	.endif
	copy_memory split_pictures_dfl_load split_pictures_dfl [ .len split_pictures_dfl_load]

;	Copy additional data
	copy_memory split_imx_load split_imx [ .len split_imx_load]
	copy_memory split_sinus_load split_sinus [ .len split_sinus_load]

;	Unpack packed picture data to begin of free memory, bottom-up
	mwa #split_pictures_dfl inflater.inputPointer 
	mwa #split_pictures_start inflater.outputPointer 
	jsr inflater.inflate

;	Copy unpacked data to end of free memory, in chunks, top-down
	mwa #split_pictures_end-split_pic_size p1
	mwa #split_chr_end-split_chr_size p2
	mvx #split_char_height-1 line_count
copy_line_loop
	jsr copy_chr

	lda line_count
	asl
	asl
	asl
	tay
	lda p2+1
	ldx #7
copy_chrtab_loop
	sta split_chrs,y+
	dex
	bpl copy_chrtab_loop

	jsr copy_chr

	dec line_count
	bpl copy_line_loop	
	rts
	.endp			;End of init

;===============================================================
	.proc copy_two_gap_pages	;Copy even number <Y> of pages into split pages
	
copy_pages
	jsr copy_page
	jsr copy_page
	inc target_adr+1
	inc target_adr+1
	dey
	bne copy_pages
	rts

copy_page
	ldx #0
page_loop
	lda $ffff,x
source_adr = *-2
	sta $ffff,x
target_adr = *-2
	inx
	bne page_loop
	inc source_adr+1
	inc target_adr+1
	rts
	.endp

;===============================================================

	.proc init_split_end_and_mask	;Make color 2 transparent
	.var or_mask .byte
	.var and_mask .byte

	ldx #0
loop	stx or_mask
	mva #0 and_mask
	jsr shift_mask
	jsr shift_mask
	jsr shift_mask
	jsr shift_mask
	sta split_end_and_mask2,x
	eor #$ff
	sta split_end_and_mask1,x
	inx
	bne loop
	rts

	.proc shift_mask
	lda or_mask
	and #3
	tay
	lsr and_mask
	lsr and_mask
	lda bit_tab,y
	ora and_mask
	sta and_mask
	lsr or_mask
	lsr or_mask
	rts

bit_tab	.byte $00,$00,$c0,$00
	.endp			;End of shift_mask
	
	.endp			;End of init_split_end_and_mask

;===============================================================

	.proc copy_chr		;Copy a charset
	ldy #0
page_loop
	lda (p1),y
	sta (p2),y
	iny
	bne page_loop
	inc p1+1
	inc p2+1
	ldy #$3f
byte_loop
	lda (p1),y
	sta (p2),y
	dey
	bpl byte_loop

	sbw p1 #$100+split_pic_size
	sec
	lda p2+1
	sbc #1+>split_chr_size

	cmp #$d8		;Skip $d00-$d7ff?
	bcs no_skip
	cmp #$d0
	bcc no_skip
	sec
	sbc #($d8-$d0)
no_skip	sta p2+1
	rts
	.endp			;End of copy_chr
	.endp			;End of pictures

;===============================================================

	
	.print " "
	.print "Silly-Splits.asm"
	info init
	info kernel
	info effect

	.if split_code_end - 1 > generated_lines
	.error "Split code ending at ", split_code_end - 1, " will be overwritten by generated_lines ", generated_lines
	.else
	.print "Still ", generated_lines - [ split_code_end - 1 ], " bytes for split code until generated_lines" 
	.endif

	.if inflater + .len inflater - 1 > split.split_pictures_start
	.error "Inflater ending at ", inflater + .len inflater - 1, " will be overwritten by split_pictures_start ", split_pictures_start
	.else
	.print "Still ", split.split_pictures_start - [ inflater + .len inflater - 1 ], " bytes for split code until split_pictures_start" 
	.endif
